/**
 * Bootstraps the application and makes the ROUTER_PROVIDERS and the APP_BASE_HREF available to it.
 * @see https://angular.io/docs/ts/latest/api/platform-browser-dynamic/index/bootstrap-function.html
 */
import { enableProdMode } from '@angular/core';
import { platformBrowser } from '@angular/platform-browser';

import { AppModuleNgFactory } from './app.module.ngfactory';

enableProdMode();

platformBrowser().bootstrapModuleFactory(AppModuleNgFactory);

// In order to start the Service Worker located at "/ngsw-worker.js"
// uncomment this line. More about Service Workers here
// https://developer.mozilla.org/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers

// if ('serviceWorker' in navigator) {
//   (<any>navigator).serviceWorker
//     .register('/ngsw-worker.js')
//     .then((registration: any) => console.log('ServiceWorker registration successful with scope: ', registration.scope))
//     .catch((err: any) => console.log('ServiceWorker registration failed: ', err));
// }
